Index: tmp/org.txm.textsbalance.rcp/src/org/txm/textsbalance/rcp/handlers/ComputeBalance.java
===================================================================
--- tmp/org.txm.textsbalance.rcp/src/org/txm/textsbalance/rcp/handlers/ComputeBalance.java	(revision 536)
+++ tmp/org.txm.textsbalance.rcp/src/org/txm/textsbalance/rcp/handlers/ComputeBalance.java	(revision 537)
@@ -58,28 +58,21 @@
 	@Override
 	public Object execute(ExecutionEvent event) throws ExecutionException {
 
-		
 		Object selection = this.getSelection();
-
+		TextsBalance textsBalance = null;
 		
-		ChartEditorInput editorInput = null;
-		
 		// creates new result
 		if(selection instanceof Corpus) {
-			editorInput = new ChartEditorInput(new TextsBalance((Corpus) selection));
+			textsBalance = new TextsBalance((Corpus) selection);
 		}
 		// reopens existing result
 		else if(selection instanceof TextsBalance) {
-			editorInput = new ChartEditorInput((TextsBalance) selection);
+			textsBalance = (TextsBalance) selection;
 		}
 		
-		ChartEditorPart editor = SWTChartsComponentsProvider.getCurrent().openEditor(editorInput);
+		// Create and open the chart editor
+		ChartEditorPart.compute(textsBalance);
 
-		// new result
-		if(!(selection instanceof TextsBalance))	{
-			editor.computeResult();
-		}
-		
 
 		// FIXME: test d'utilisation de la même commande pour la création d'un nouvel éditeur et pour la mise à jour d'un graphique, avec une commande paramétrée (voir plugin.xml)
 //		if(event.getParameter("TextsBalance.createNewEditor") == null)	{
Index: tmp/org.txm.textsbalance.rcp/src/org/txm/textsbalance/rcp/editors/TextsBalanceEditor.java
===================================================================
--- tmp/org.txm.textsbalance.rcp/src/org/txm/textsbalance/rcp/editors/TextsBalanceEditor.java	(revision 0)
+++ tmp/org.txm.textsbalance.rcp/src/org/txm/textsbalance/rcp/editors/TextsBalanceEditor.java	(revision 537)
@@ -0,0 +1,338 @@
+package org.txm.textsbalance.rcp.editors;
+
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.List;
+
+import org.eclipse.core.runtime.IProgressMonitor;
+import org.eclipse.core.runtime.IStatus;
+import org.eclipse.core.runtime.Status;
+import org.eclipse.core.runtime.jobs.Job;
+import org.eclipse.swt.SWT;
+import org.eclipse.swt.events.SelectionEvent;
+import org.eclipse.swt.events.SelectionListener;
+import org.eclipse.swt.layout.RowLayout;
+import org.eclipse.swt.widgets.Button;
+import org.eclipse.swt.widgets.Combo;
+import org.eclipse.swt.widgets.Composite;
+import org.eclipse.swt.widgets.Group;
+import org.txm.chartsengine.rcp.editors.ChartEditorPart;
+import org.txm.core.preferences.TXMPreferences;
+import org.txm.rcp.views.corpora.CorporaView;
+import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
+import org.txm.searchengine.cqp.corpus.StructuralUnit;
+import org.txm.searchengine.cqp.corpus.StructuralUnitProperty;
+import org.txm.searchengine.cqp.corpus.query.Match;
+import org.txm.textsbalance.core.functions.TextsBalance;
+import org.txm.textsbalance.core.preferences.TextsBalancePreferences;
+import org.txm.utils.logger.Log;
+
+/**
+ * Texts balance editor.
+ * 
+ * @author mdecorde
+ * @author sjacquot
+ *
+ */
+public class TextsBalanceEditor extends ChartEditorPart {
+
+	private Combo supCombo;
+
+	private Button groupByTexts;
+
+	private Button groupByWords;
+
+	private Combo suCombo;
+
+	/**
+	 * Structural unit properties to not display.
+	 */
+	protected String[] supsToSkip;
+	
+	
+	/**
+	 * 
+	 */
+	public TextsBalanceEditor() {
+		this.supsToSkip = new String[] {"id", "base", "project"}; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+	}
+
+	
+	@Override
+	public void createPartControl(Composite parent) {
+		super.createPartControl(parent);
+		
+		if (((TextsBalance)this.getResultData()).getCorpus() == null) {
+			System.out.println("Error: no corpus");
+			return;
+		}
+
+		
+		// for group tests
+		Composite p = this.getCommandParametersGroup();
+		// for tab folder tests
+		//Composite p = this.getCommandParametersComposite();
+
+		
+		
+		Group group = new Group(p, SWT.NONE);
+		
+		group.setText("Group by:");
+		//group.setLayout(new RowLayout(SWT.VERTICAL));
+		group.setLayout(new RowLayout());
+		
+//		GridData gridData = new GridData(SWT.FILL, SWT.FILL, true, false);
+//		gridData.horizontalSpan = 2;
+//		gridData.verticalIndent = 10;
+//		group.setLayoutData(gridData);
+
+		
+		groupByTexts = new Button(group, SWT.RADIO);
+		groupByTexts.setText("text");
+		groupByTexts.setSelection(!this.getBooleanParameterValue(TextsBalancePreferences.GROUP_BY_WORDS));	
+		
+		
+		groupByWords = new Button(group, SWT.RADIO);
+		groupByWords.setText("word");
+		groupByWords.setSelection(!groupByTexts.getSelection());
+
+		
+		suCombo = new Combo(p, SWT.READ_ONLY);
+		supCombo = new Combo(p, SWT.READ_ONLY);
+
+		try {
+			loadSU();
+		}
+		catch (Exception e) {
+			e.printStackTrace();
+		}
+
+
+		suCombo.addSelectionListener(new SelectionListener() {
+			
+			@Override
+			public void widgetSelected(SelectionEvent e) {
+				// persistence
+				TXMPreferences.putLocalString(getResultData(), TextsBalancePreferences.STRUCTURAL_UNIT, suCombo.getText());
+				TXMPreferences.putLocalInt(getResultData(), TextsBalancePreferences.STRUCTURAL_UNIT_PROPERTY_INDEX, 0);
+				
+				try {
+					loadSUP(((TextsBalance)getResultData()).getCorpus().getStructuralUnit(suCombo.getText()));
+					getResultData().setDirty();
+					computeChart(true);
+				}
+				catch(Exception e1) {
+					// TODO Auto-generated catch block
+					e1.printStackTrace();
+				}
+
+			}
+			
+			@Override
+			public void widgetDefaultSelected(SelectionEvent e) {
+				// TODO Auto-generated method stub
+				
+			}
+		});
+		
+
+		
+		SelectionListener listener = new SelectionListener() {
+			@Override
+			public void widgetSelected(SelectionEvent e) {
+				
+			
+				// persistence
+				TXMPreferences.putLocalInt(getResultData(), TextsBalancePreferences.STRUCTURAL_UNIT_PROPERTY_INDEX, supCombo.getSelectionIndex());
+				TXMPreferences.putLocalBoolean(getResultData(), TextsBalancePreferences.GROUP_BY_WORDS, !groupByTexts.getSelection());
+				getResultData().setDirty();
+				computeChart(true);
+			}
+
+			@Override
+			public void widgetDefaultSelected(SelectionEvent e) {
+				
+			}
+		};
+		
+		supCombo.addSelectionListener(listener);
+		groupByTexts.addSelectionListener(listener);
+		groupByWords.addSelectionListener(listener);
+		
+		
+		//this.compute();
+	}
+
+	
+//	/**
+//	 * Computes the balance using local or default parameters.
+//	 */
+//	public void compute()	{
+//		try {
+//			
+//			String suName = this.getStringParameterValue(TextsBalancePreferences.STRUCTURAL_UNIT);
+//
+//			// gets the structural unit property name
+//			String supName = null;
+//			int i = 0;
+//			for(StructuralUnitProperty p : ((TextsBalance) this.getResultData()).getCorpus().getStructuralUnit(suName).getOrderedProperties()) {
+//				if(Arrays.asList(this.supsToSkip).contains(p.getName()))	{ 
+//					continue;
+//				}
+//				if(i == this.getIntParameterValue(TextsBalancePreferences.STRUCTURAL_UNIT_PROPERTY_INDEX))	{
+//					supName = p.getName();
+//					break;
+//				}
+//				i++;
+//			}
+//			
+//			this.compute(
+//					this.getIntParameterValue(TextsBalancePreferences.METHOD),
+//					((TextsBalance) this.getResultData()).getCorpus().getStructuralUnit(suName),
+//					supName,
+//					!this.getBooleanParameterValue(TextsBalancePreferences.GROUP_BY_WORDS)
+//					);
+//			
+//			
+//		}
+//		catch(Exception e) {
+//			// TODO Auto-generated catch block
+//			e.printStackTrace();
+//		}
+//	}
+//	
+//	
+//	/**
+//	 * 
+//	 * @param method 1: use CQL to solve matches, 2 uses corpus struct indexes, 2 is faster !
+//	 * @throws CqiClientException
+//	 */
+//	public void compute(final int method, final StructuralUnit su, final String propertyName, final boolean groupByTexts) {
+//
+//		Job job = new Job("Compute Texts Balance") {
+//		    @Override
+//		    protected IStatus run(IProgressMonitor monitor) {
+//
+//		    	// creating
+//				monitor.beginTask("Computing", IProgressMonitor.UNKNOWN);
+//				
+//				final TextsBalance textsBalance = (TextsBalance)getResultData();
+//				try {
+//					textsBalance.setParameters(method, su, propertyName, groupByTexts);
+//					textsBalance.compute(false, monitor);
+//				}
+//				catch(Exception e) {
+//					System.out.println("Error: "+e.getLocalizedMessage());
+//					Log.printStackTrace(e);
+//				}
+//		
+//				computeChart(true);
+//				
+//				// done
+//				monitor.done(); 
+//				return Status.OK_STATUS;
+//	    }
+//
+//		};
+//		//job.setUser(true); // show progress bar, without that the progress is located to bottom right
+//		job.schedule();
+//		
+//		
+//	}
+
+	
+	
+	/**
+	 * Fills the SU combo box from the corpus.
+	 * @throws CqiClientException
+	 */
+	private void loadSU() throws CqiClientException {
+
+		String selectedSuName = TextsBalancePreferences.getString(TextsBalancePreferences.PREFERENCES_NODE, (TextsBalance) this.getResultData(), TextsBalancePreferences.STRUCTURAL_UNIT);
+		int selectedIndex = 0;
+		int i = 0;
+		
+		for (StructuralUnit p : ((TextsBalance) this.getResultData()).getCorpus().getOrderedStructuralUnits()) {
+			if (p.getName().equals("txmcorpus"))	{ //$NON-NLS-1$
+				continue;
+			}
+			suCombo.add(p.getName());
+			if (selectedSuName.equals(p.getName()))	{
+				selectedIndex = i;
+			}
+			i++;
+		}
+		suCombo.select(selectedIndex);
+		loadSUP(((TextsBalance)this.getResultData()).getCorpus().getStructuralUnit(suCombo.getText()));
+	}
+
+	/**
+	 * Fills the SUP combo box from the specified structural unit.
+	 * @param su
+	 * @throws CqiClientException
+	 */
+	private void loadSUP(StructuralUnit su) throws CqiClientException {
+		supCombo.removeAll();
+		for (StructuralUnitProperty p : su.getOrderedProperties()) {
+			if (Arrays.asList(this.supsToSkip).contains(p.getName()))	{ 
+				continue;
+			}
+			supCombo.add(p.getName());
+		}
+		if (supCombo.getItemCount() > 0) {
+			supCombo.select(TextsBalancePreferences.getInt(TextsBalancePreferences.PREFERENCES_NODE, this.getResultData(), TextsBalancePreferences.STRUCTURAL_UNIT_PROPERTY_INDEX));
+		}
+	}
+	
+	/**
+	 * 
+	 * @param corpus
+	 * @param structs
+	 * @return
+	 */
+	public ArrayList<Integer> intersect(List<Match> corpus, List<Match> structs) {
+		int ai=0, bi=0;
+		ArrayList<Integer> result = new ArrayList<Integer>();
+
+		while (ai < corpus.size() && bi < structs.size() ) {
+			if (structs.get(bi).contains(corpus.get(ai))) { 
+				result.add(bi);
+				ai++; 
+			} else if (corpus.get(ai).contains(structs.get(bi))) { 
+				result.add(bi);
+				bi++; 
+			} else { 
+				if (structs.get(bi).getStart() < corpus.get(ai).getStart()) {
+					bi++;
+				} else {
+					ai++;	
+				}
+			} 
+		}
+
+		return result;
+	}
+
+	@Override
+	public void doSave(IProgressMonitor monitor) {
+		// Do the Save operation
+	}
+
+	@Override
+	public void doSaveAs() {
+		// Do the Save As operation
+	}
+
+
+	@Override
+	public boolean isDirty() {
+		return false;
+	}
+
+	@Override
+	public boolean isSaveAsAllowed() {
+		return false;
+	}
+
+
+}

Index: tmp/org.txm.progression.core/src/org/txm/progression/core/functions/Progression.java
===================================================================
--- tmp/org.txm.progression.core/src/org/txm/progression/core/functions/Progression.java	(revision 536)
+++ tmp/org.txm.progression.core/src/org/txm/progression/core/functions/Progression.java	(revision 537)
@@ -41,6 +41,7 @@
 import org.txm.chartsengine.r.core.themes.DefaultTheme;
 import org.txm.core.results.TXMParameters;
 import org.txm.progression.core.messages.ProgressionCoreMessages;
+import org.txm.progression.core.preferences.ProgressionPreferences;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.corpus.Corpus;
 import org.txm.searchengine.cqp.corpus.CorpusManager;
@@ -70,7 +71,7 @@
 	List<Query> queries;
 
 	/** The structure. */
-	StructuralUnit structure;
+	StructuralUnit structuralUnit;
 
 	/** The property. */
 	StructuralUnitProperty property;
@@ -88,13 +89,13 @@
 	private BufferedWriter writer;
 
 	/** List of token position in the text. */
-	List<int[]> allPositions = new ArrayList<int[]>();
+	List<int[]> allPositions;
 
 	/** The structurepositions. */
-	int[] structurePositions = new int[0];
+	int[] structurePositions;
 
 	/** The structurenames. */
-	String[] structureNames = new String[0];
+	String[] structureNames;
 
 	/** graph boundaries. */
 	int maxY;
@@ -105,13 +106,13 @@
 
 
 	/** The repeatvalues. */
-	private boolean repeatvalues;
+	private boolean repeatValues;
 
 	/** The bande. */
 	private float bande = 0.0f;
 
 	/** The bandemultiplier. */
-	private float bandemultiplier;
+	private float bandeMultiplier;
 
 	
 	/** The norep. */
@@ -125,45 +126,81 @@
 	
 	
 	/**
-	 * Instantiates a new progression.
-	 *
-	 * @param corpus the corpus
-	 * @param queries , a curve per query
-	 * @param structure , the structural unit to show
-	 * @param property , the value to display
-	 * @param propertyregex , a selection of the values to display
-	 * @param doCumulative , if true do a cumulative graph, if not compute the density (R
-	 * function)
-	 * @param monochrome the monochrome
-	 * @param monostyle the monostyle
-	 * @param linewidth the linewidth
-	 * @param repeat the repeat
-	 * @param bandemultiplier the bandemultiplier
+	 * Creates an empty Progression result with no parent.
+	 * @param corpus
 	 */
-	@Deprecated
-	// FIXME : to remove when charts engine will be validated
+	public Progression(Corpus corpus)	{
+		super();
+		this.corpus = corpus;
+	}
+	
+
+	
+	@Override
+	public boolean canCompute() {
+		// FIXME: not yet implemented
+		System.err.println("Progression.canCompute(): partially implemented.");
+		return 
+				this.corpus != null
+				&& this.queries != null
+				;
+	}
+
+	/**
+	 * 
+	 * @param queries
+	 * @param structuralUnit
+	 * @param property
+	 * @param propertyregex
+	 * @param doCumulative
+	 * @param lineWidth
+	 * @param repeatValues
+	 * @param bandeMultiplier
+	 */
 	// FIXME : all parameters related to rendering should removed from this class and centralized in the charts engine system
-	public Progression(Corpus corpus, List<Query> queries, StructuralUnit structure, StructuralUnitProperty property, String propertyregex,
-			boolean doCumulative, int linewidth, boolean repeat, float bandemultiplier) {
-		
-		super(corpus);
-		
-		//System.out.println("monochrome: "+monochrome+" monostyle: "+monostyle+" width: "+linewidth);
-		this.corpus = corpus; // the corpus which we compute on
+	public void setParameters(List<Query> queries, StructuralUnit structuralUnit, StructuralUnitProperty property, String propertyregex, boolean doCumulative, int lineWidth, boolean repeatValues, float bandeMultiplier)	{
 		this.queries = queries; // the query of the selection
-		this.structure = structure;
+		this.structuralUnit = structuralUnit;
 		this.property = property;
 		this.propertyRegex = propertyregex;
-		this.repeatvalues = repeat;
-		this.bandemultiplier = bandemultiplier;
+		this.repeatValues = repeatValues;
+		this.bandeMultiplier = bandeMultiplier;
 
-		for (int i = 0 ; i < DefaultTheme.monowidths.length ; i++) {
-			DefaultTheme.monowidths[i] = linewidth;
+		for (int i = 0 ; i < DefaultTheme.monoWidths.length ; i++) {
+			DefaultTheme.monoWidths[i] = lineWidth;
 		}
+		
+		this.setDirty();
 	}
-
 	
 	/**
+	 * 
+	 * @param structuralUnit
+	 */
+	public void setStructuralUnit(StructuralUnit structuralUnit)	{
+		this.structuralUnit = structuralUnit;
+	}
+	
+	/**
+	 * 
+	 * @param structuralUnitProperty
+	 */
+	public void setStructuralUnitProperty(StructuralUnitProperty structuralUnitProperty)	{
+		this.property = structuralUnitProperty;
+	}
+	
+// FIXME	
+//	@Override
+//	public void loadParameters() {
+//		// FIXME:
+//		System.err.println("Progression.loadParameters(): partially implemented.");
+//		
+//		this.repeatValues = this.getBooleanParameterValue(ProgressionPreferences.CHART_REPEAT_VALUES);
+//		this.bandeMultiplier = this.getFloatParameterValue(ProgressionPreferences.CHART_BANDE_MULTIPLIER);
+//	}
+	
+	
+	/**
 	 * Computes.
 	 *
 	 * @return true, if successful
@@ -173,17 +210,24 @@
 	 */
 	protected boolean _compute(boolean update) throws Exception {
 		
-		this.subTask("processing queries");
-		if (!stepQueries()) {
-			System.out.println(ProgressionCoreMessages.ComputeProgression_3);
-			return false;
+		if(!update)	{
+			this.allPositions = new ArrayList<int[]>();
+			this.structurePositions = new int[0];
+			this.structureNames = new String[0];
+			
+			this.subTask("processing queries");
+			if (!stepQueries()) {
+				System.out.println(ProgressionCoreMessages.ComputeProgression_3);
+				return false;
+			}
+			
+			if (this.isCanceled())	{
+				return false;
+			}
+			this.worked(10);
+
 		}
 		
-		if (this.isCanceled())	{
-			return false;
-		}
-		this.worked(10);
-
 		
 		this.subTask("processing structural units");
 		if (!stepStructuralUnits() || this.isCanceled())	{
@@ -191,12 +235,17 @@
 		}
 		this.worked(20);
 
-		this.subTask("finalizing");
-		if (!stepFinalize() || this.isCanceled())	{
-			return false;
+		
+		if(!update)	{
+			this.subTask("finalizing");
+			if (!stepFinalize() || this.isCanceled())	{
+				return false;
+			}
+			this.worked(20);
+			
+			this.corpus.addResult(this);
 		}
-		this.worked(20);
-
+		
 		return true;
 	}
 
@@ -207,7 +256,9 @@
 	 */
 	public static boolean canRunProgression(Corpus corpus) {
 		//System.out.println(corpus.getMatches());
-		if (corpus.getMatches().size() == 1) return true;
+		if (corpus.getMatches().size() == 1) {
+			return true;
+		}
 		else {
 			Match previousMatch = null;
 			for (Match m : corpus.getMatches()) {
@@ -262,10 +313,12 @@
 				this.worked(1);
 				
 				// FIXME: long process test for Thread user canceling
-				System.err.println("Progression.stepQueries(): fixme: simulating a long process for canceling tests purpose.");
-				for(long j = 0; j < 100000000L; j++)	{
-					;
-				}
+//				System.err.println("Progression.stepQueries(): fixme: simulating a long process for canceling tests purpose.");
+//				for(long j = 0; j < 10000000L; j++)	{
+//					;
+//				}
+
+				
 			}
 		}
 		return npositions > 0;
@@ -280,8 +333,8 @@
 	 */
 	public boolean stepStructuralUnits() throws CqiClientException, IOException, CqiServerError	{
 		// structure query
-		if (structure != null) {
-			Query query = new Query("<" + structure.getName() + ">[]"); //$NON-NLS-1$ //$NON-NLS-2$
+		if (structuralUnit != null) {
+			Query query = new Query("<" + structuralUnit.getName() + ">[]"); //$NON-NLS-1$ //$NON-NLS-2$
 			if (property != null) {
 				query = new Query("<" + property.getFullName() + ">[]"); //$NON-NLS-1$ //$NON-NLS-2$
 				if (propertyRegex != null)
@@ -322,9 +375,9 @@
 				if (property != null)
 					currentname = refValues.get(property).get(i);
 				else
-					currentname = structure.getName() + i;
+					currentname = structuralUnit.getName() + i;
 
-				if (repeatvalues) {
+				if (repeatValues) {
 					structureNames[i] = currentname;
 					structurePositions[i] = m;
 				} else {
@@ -345,7 +398,7 @@
 
 				i++;
 			}
-			this.bande = distmin*bandemultiplier;
+			this.bande = distmin * this.bandeMultiplier;
 		}
 		return true;
 	}
@@ -372,36 +425,13 @@
 		//System.out.println("min: "+XminCorpus+ "max: "+XmaxCorpus);
 
 		if (bande <= 0) {
-			bande = ((XmaxCorpus - XminCorpus)/100)*bandemultiplier;
+			bande = ((XmaxCorpus - XminCorpus)/100)*bandeMultiplier;
 			if (bande == 0)
 				bande = 1.0f;
 		}
 		return true;
 	}
 
-	/**
-	 * 
-	 * @param outfile
-	 * @param encoding
-	 * @return
-	 * @throws IOException
-	 */
-	public boolean toTxt(File outfile, String encoding) throws IOException {
-		// NK: writer declared as class attribute to perform a clean if the operation is interrupted
-		tryAcquireSemaphore();
-		this.writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(outfile),
-				encoding)); 
-		for (int i = 0 ; i < queries.size() ; i++) {
-			writer.write("* "+queries.get(i)+"\n"); //$NON-NLS-1$ //$NON-NLS-2$
-			for (int p : allPositions.get(i)) {
-				writer.write(""+p+"\n"); //$NON-NLS-1$ //$NON-NLS-2$
-			}
-		}
-		writer.close();
-		releaseSemaphore();
-		return true;
-	}
-	
 
 
 
@@ -470,7 +500,7 @@
 	 * @return true, if is repeatvalues
 	 */
 	public boolean isRepeatvalues() {
-		return repeatvalues;
+		return repeatValues;
 	}
 
 
@@ -495,7 +525,32 @@
 		return toTxt(outfile, encoding);
 	}
 
+
 	/**
+	 * 
+	 * @param outfile
+	 * @param encoding
+	 * @return
+	 * @throws IOException
+	 */
+	public boolean toTxt(File outfile, String encoding) throws IOException {
+		// NK: writer declared as class attribute to perform a clean if the operation is interrupted
+		tryAcquireSemaphore();
+		this.writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(outfile),
+				encoding)); 
+		for (int i = 0 ; i < queries.size() ; i++) {
+			writer.write("* "+queries.get(i)+"\n"); //$NON-NLS-1$ //$NON-NLS-2$
+			for (int p : allPositions.get(i)) {
+				writer.write(""+p+"\n"); //$NON-NLS-1$ //$NON-NLS-2$
+			}
+		}
+		writer.close();
+		releaseSemaphore();
+		return true;
+	}
+	
+	
+	/**
 	 * @return the allPositions
 	 */
 	public List<int[]> getAllPositions() {
@@ -520,7 +575,7 @@
 	 * @return the structure
 	 */
 	public StructuralUnit getStructure() {
-		return structure;
+		return structuralUnit;
 	}
 
 	/**
@@ -620,25 +675,25 @@
 			return this.parent.getSimpleName() + ": " + this.getSimpleName();			
 		}
 		catch(Exception e) {
-			return super.toString();
+			return "";
 		}
 
 	}
 
 	@Override
 	public String getSimpleName() {
-		return this.queries.toString();
+		String output  = this.queries.toString();
+		if (this.propertyRegex != null) {
+			output += " " + this.propertyRegex;
+		}
+		return output;
 	}
 
-	@Override
-	public boolean canCompute() {
-		// FIXME: not yet implemented
-		System.err.println("Progression.canCompute(): not yet implemented.");
-		return corpus != null;
-	}
 
 	@Override
 	public boolean setParameters(TXMParameters parameters) {
 		return false;
 	}
+
+
 }
Index: tmp/org.txm.progression.core/src/org/txm/progression/core/chartsengine/r/RProgressionChartCreator.java
===================================================================
--- tmp/org.txm.progression.core/src/org/txm/progression/core/chartsengine/r/RProgressionChartCreator.java	(revision 536)
+++ tmp/org.txm.progression.core/src/org/txm/progression/core/chartsengine/r/RProgressionChartCreator.java	(revision 537)
@@ -104,7 +104,7 @@
 
 			// System.out.println("create styles vector");
 			rw.eval("rm(widths)"); //$NON-NLS-1$
-			rw.addVectorToWorkspace("widths", DefaultTheme.monowidths); //$NON-NLS-1$
+			rw.addVectorToWorkspace("widths", DefaultTheme.monoWidths); //$NON-NLS-1$
 
 			// System.out.println("create names vector");
 			String[] queriesstring = new String[progression.getQueries().size()];
Index: tmp/org.txm.concordance.core/src/org/txm/concordance/core/functions/Concordance.java
===================================================================
--- tmp/org.txm.concordance.core/src/org/txm/concordance/core/functions/Concordance.java	(revision 536)
+++ tmp/org.txm.concordance.core/src/org/txm/concordance/core/functions/Concordance.java	(revision 537)
@@ -127,33 +127,33 @@
 		}
 
 		// initialize default preference values of this Concordance
-		try {
-			this.parameters = new TXMParameters();
-			this.parameters.put(ConcordancePreferences.QUERY, this.getStringParameterValue(ConcordancePreferences.QUERY));
-			this.parameters.put(ConcordancePreferences.LEFT_ANALYSIS_PROPERTIES, this.getStringParameterValue(ConcordancePreferences.LEFT_ANALYSIS_PROPERTIES));
-			this.parameters.put(ConcordancePreferences.KEYWORD_ANALYSIS_PROPERTIES, this.getStringParameterValue(ConcordancePreferences.KEYWORD_ANALYSIS_PROPERTIES));
-			this.parameters.put(ConcordancePreferences.RIGHT_ANALYSIS_PROPERTIES, this.getStringParameterValue(ConcordancePreferences.RIGHT_ANALYSIS_PROPERTIES));
-			this.parameters.put(ConcordancePreferences.LEFT_VIEW_PROPERTIES, this.getStringParameterValue(ConcordancePreferences.LEFT_VIEW_PROPERTIES));
-			this.parameters.put(ConcordancePreferences.KEYWORD_VIEW_PROPERTIES, this.getStringParameterValue(ConcordancePreferences.KEYWORD_VIEW_PROPERTIES));
-			this.parameters.put(ConcordancePreferences.RIGHT_VIEW_PROPERTIES, this.getStringParameterValue(ConcordancePreferences.RIGHT_VIEW_PROPERTIES));
-
-			this.parameters.put(ConcordancePreferences.LEFT_CONTEXT_SIZE, this.getIntParameterValue(ConcordancePreferences.LEFT_CONTEXT_SIZE));
-			this.parameters.put(ConcordancePreferences.RIGHT_CONTEXT_SIZE, this.getIntParameterValue(ConcordancePreferences.RIGHT_CONTEXT_SIZE));
-
-			Property ref = corpus.getProperty("ref");
-			if (ref != null) {
-				this.parameters.put(ConcordancePreferences.VIEW_REFERENCEPATTERN, ref);
-				this.parameters.put(ConcordancePreferences.ANALYSIS_REFERENCEPATTERN, ref);
-			} else {
-				this.parameters.put(ConcordancePreferences.VIEW_REFERENCEPATTERN, "text_id");
-				this.parameters.put(ConcordancePreferences.ANALYSIS_REFERENCEPATTERN, "text_id");
-			}
-
-			this.setParameters(this.parameters);
-		} catch (CqiClientException e) {
-			// TODO Auto-generated catch block
-			e.printStackTrace();
-		}
+//		try {
+//			this.parameters = new TXMParameters();
+//			this.parameters.put(ConcordancePreferences.QUERY, this.getStringParameterValue(ConcordancePreferences.QUERY));
+//			this.parameters.put(ConcordancePreferences.LEFT_ANALYSIS_PROPERTIES, this.getStringParameterValue(ConcordancePreferences.LEFT_ANALYSIS_PROPERTIES));
+//			this.parameters.put(ConcordancePreferences.KEYWORD_ANALYSIS_PROPERTIES, this.getStringParameterValue(ConcordancePreferences.KEYWORD_ANALYSIS_PROPERTIES));
+//			this.parameters.put(ConcordancePreferences.RIGHT_ANALYSIS_PROPERTIES, this.getStringParameterValue(ConcordancePreferences.RIGHT_ANALYSIS_PROPERTIES));
+//			this.parameters.put(ConcordancePreferences.LEFT_VIEW_PROPERTIES, this.getStringParameterValue(ConcordancePreferences.LEFT_VIEW_PROPERTIES));
+//			this.parameters.put(ConcordancePreferences.KEYWORD_VIEW_PROPERTIES, this.getStringParameterValue(ConcordancePreferences.KEYWORD_VIEW_PROPERTIES));
+//			this.parameters.put(ConcordancePreferences.RIGHT_VIEW_PROPERTIES, this.getStringParameterValue(ConcordancePreferences.RIGHT_VIEW_PROPERTIES));
+//
+//			this.parameters.put(ConcordancePreferences.LEFT_CONTEXT_SIZE, this.getIntParameterValue(ConcordancePreferences.LEFT_CONTEXT_SIZE));
+//			this.parameters.put(ConcordancePreferences.RIGHT_CONTEXT_SIZE, this.getIntParameterValue(ConcordancePreferences.RIGHT_CONTEXT_SIZE));
+//
+//			Property ref = corpus.getProperty("ref");
+//			if (ref != null) {
+//				this.parameters.put(ConcordancePreferences.VIEW_REFERENCEPATTERN, ref);
+//				this.parameters.put(ConcordancePreferences.ANALYSIS_REFERENCEPATTERN, ref);
+//			} else {
+//				this.parameters.put(ConcordancePreferences.VIEW_REFERENCEPATTERN, "text_id");
+//				this.parameters.put(ConcordancePreferences.ANALYSIS_REFERENCEPATTERN, "text_id");
+//			}
+//
+//			this.setParameters(this.parameters);
+//		} catch (CqiClientException e) {
+//			// TODO Auto-generated catch block
+//			e.printStackTrace();
+//		}
 	}
 
 	public void setParameters(Query query,
@@ -1051,7 +1051,6 @@
 
 	@Override
 	public boolean setParameters(TXMParameters parameters) {
-		this.parameters = parameters;
 
 		Object p = parameters.get(ConcordancePreferences.QUERY);
 		if (p != null) {
Index: tmp/org.txm.chartsengine.svgbatik.rcp/src/org/txm/chartsengine/svgbatik/rcp/swt/SVGComposite.java
===================================================================
--- tmp/org.txm.chartsengine.svgbatik.rcp/src/org/txm/chartsengine/svgbatik/rcp/swt/SVGComposite.java	(revision 536)
+++ tmp/org.txm.chartsengine.svgbatik.rcp/src/org/txm/chartsengine/svgbatik/rcp/swt/SVGComposite.java	(revision 537)
@@ -1,5 +1,6 @@
 package org.txm.chartsengine.svgbatik.rcp.swt;
 import java.awt.BorderLayout;
+import java.awt.Component;
 import java.awt.EventQueue;
 import java.awt.Frame;
 import java.awt.Graphics2D;
@@ -13,8 +14,11 @@
 import java.io.IOException;
 import java.net.MalformedURLException;
 
+import javax.swing.JPanel;
+
 import org.eclipse.swt.awt.SWT_AWT;
 import org.eclipse.swt.widgets.Composite;
+import org.txm.chartsengine.rcp.IChartComponent;
 import org.txm.chartsengine.rcp.editors.ChartEditorPart;
 import org.txm.chartsengine.rcp.events.EventCallBackHandler;
 import org.txm.chartsengine.rcp.swt.ChartComposite;
@@ -43,8 +47,11 @@
 	 */
 	protected File file;
 	
-
+	protected Frame frame;
 	
+	protected JPanel rootPanel;
+	
+	
 	/**
 	 * Creates a Batik SVG composite.
 	 * @param parent
@@ -55,14 +62,15 @@
 	
 		this.file = null;
 		
-		Frame frame = SWT_AWT.new_Frame(this);
+		this.frame = SWT_AWT.new_Frame(this);
+		// Need to add an AWT Panel to fix mouse events and mouse cursors changes on Swing JPanel
+		this.rootPanel = new JPanel(new BorderLayout());
 		
-		// Need to add an AWT Panel to fix mouse events and mouse cursors changes on Swing JPanel
-		Panel rootPanel = new Panel(new BorderLayout());
-		this.chartComponent = new SVGPanel(chartEditor, frame);
-		rootPanel.add(this.getPanel());
-		frame.add(rootPanel);
-		frame.pack();
+		this.frame.add(this.rootPanel);
+
+		//this.frame.pack();
+		this.frame.setVisible(true);
+		
 	}
 
 
@@ -118,8 +126,29 @@
 	
 	@Override
 	public void loadChart()	{
-		this.file = (File) this.chartEditor.getEditorInput().getChartContainer();
-		this.loadSVGDocument(this.file);
+		if(!this.chartEditor.getResultData().isChartDirty())	{
+			// creates components if they not exist
+			if(this.chartComponent == null)	{
+				
+				this.chartEditor.getSWTChartsComponentsProvider().createChartContainer(this.chartEditor.getEditorInput());
+				this.chartComponent = (IChartComponent) this.chartEditor.getEditorInput().getChartContainer();
+				
+				this.rootPanel.add((Component) this.chartComponent);
+
+				this.frame.setVisible(true);
+			}
+			// loads the chart from the result
+			Object chart = this.chartEditor.getEditorInput().getChart();
+			// recreates the chart if not of right type
+			if(!(chart instanceof File))	{
+				this.file = this.chartEditor.getSWTChartsComponentsProvider().getChartsEngine().getChartCreator(this.chartEditor.getResultData()).createChartFile(this.chartEditor.getResultData());
+			}
+			else	{
+				this.file = (File) chart;	
+			}
+			
+			this.loadSVGDocument(this.file);
+		}
 	}
 	
 	
